#!/bin/sh
#
# This is a patch after script,  generated by the patchgen script.
# You should not edit this file.
#
_TMP="$TMP"
if [ "x$_TMP" != x ]; then
    # Unscrew NuTcracker screwyness.
    _TMP=`echo "$_TMP" | sed 's!/\([a-zA-Z]\)=/!\1:/!g'`
    if [ ! -d "$_TMP" ]; then
	unset _TMP
    fi
fi
if [ "x$_TMP" = x ]; then
    # This should be a no-op on Unix, but on NT the chances are good that
    # there really will be a $DBDIR/tmp.
    if [ -d tmp ]; then
	_TMP=`pwd`/tmp
    else
	_TMP=/tmp
	if [ ! -d /tmp ]; then
	    mkdir /tmp
	fi
    fi
fi
export _TMP

if [ -f /tmp/TransferEnv ] ; then
    set -a
    . /tmp/TransferEnv
fi

PatchId=SYDM_ESM11_10SYB_ALIDB_$1
PATH=${PATH}:/usr/ucb

if [ -d "$ThisDir" ]; then
    cd $ThisDir
fi

sh >$_TMP/${PatchId}.output 2>$_TMP/${PatchId}.error <<\MAIN_EOF
set -xe

#
# Get the NameRegistry, InterfaceRepository and Library object IDs
# If the appropriate env variables are already set, then we
# don't need to get them again.  Additionally, if we need to get
# the InterfaceRepository oid, go ahead and put it into replace mode.
#
NameRegistry=${NameRegistry:-`wlookup NameRegistry`}
export NameRegistry
TNR=$NameRegistry
export TNR

Library=${Library:-`wlookup Library`}
export Library
CLO=$Library
export CLO

if [ -z "$InterfaceRepository" ] ; then
	InterfaceRepository=`wlookup InterfaceRepository`
        export InterfaceRepository
	idlattr -s -t $InterfaceRepository replace_mode boolean TRUE
fi

#################################################
# /tivoli/dbmx/builds/ALL.1.0.B/src/ESMCommon/scripts/patchgen.pl generated after script
# PatchId:	SYB_SNT_1.0
#
# Executing after script:  ESM/INSTALL/SYDM_ESM11_10SYB.After.init
sh -xe <<\ALIDB_EOF

#**************************************************************************
#
# File    : @(#M) SYDM_ESM11_10SYB.After.init @(#M)
#
# Version : @(#I) /main/8 @(#I)
#
# Created : @(#E) 97/03/13 18:24:43 @(#E)
#
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#
# DESCRIPTION
#
# Installation script for the basic ESM Sybase Sentry
#
# By the time this script is called, all the classes will have
# been created, so we just need to call all the .init scripts in
# the right order.
#
# All the object IDs for the classes are available in the environment,
# having the same names as they are given in the .cfg script.
#
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#
# EXAMPLE OF USE
#
# Takes no parameters.
# Is in-lined in the patchgen generated install script.
#
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#
# CHANGE LOG
#
# Date    By       Reason
# ------  ----     ----------------------------------------------------------
# 130398  Wfrankli Created
# 010598  Wfrankli Added section to set class inheritance information
#
#**************************************************************************

OID=`wlookup -r ProductInfo ESM_SybaseSentry`

idlcall $OID _set_description  '"TME 10 Module For Sybase - Distributed Monitoring, Version 1.0"'

idlcall $OID _set_label  '"SybaseSentry"'

#**************************************************************************
#
#  This section added to set needed class inheritance information
#
#**************************************************************************

set +e
Sentry_CO=`wlookup -r Classes SentryEndpoint 2>/dev/null`
set -e

if [ "X$Sentry_CO" = X ]
then
CLO=`wlookup Library`
Sentry_CO=`objcall $CLO _lookup_object imp_Sentry::Endpoint`
fi

TaskRepository_CO=`wlookup -r Classes TaskRepository`

ESMSybaseBackupServerBase_CO=`wlookup -r Classes SybaseBackupServer`
ESMSybaseDataServerBase_CO=`wlookup -r Classes SybaseDataServer`
ESMSybaseDatabaseBase_CO=`wlookup -r Classes SybaseDatabase`
ESMSybaseMonitorServerBase_CO=`wlookup -r Classes SybaseMonitorServer`

winstendpt $Sentry_CO $ESMSybaseBackupServerBase_CO
winstendpt $TaskRepository_CO $ESMSybaseBackupServerBase_CO

winstendpt $Sentry_CO $ESMSybaseDataServerBase_CO
winstendpt $TaskRepository_CO $ESMSybaseDataServerBase_CO

winstendpt $Sentry_CO $ESMSybaseDatabaseBase_CO
winstendpt $TaskRepository_CO $ESMSybaseDatabaseBase_CO

winstendpt $Sentry_CO $ESMSybaseMonitorServerBase_CO
winstendpt $TaskRepository_CO $ESMSybaseMonitorServerBase_CO


exit 0

ALIDB_EOF

MAIN_EOF

SSSTAT=$?
# any output needs to go to stderr
	 
if [ $SSSTAT -ne 0 ]; then
    echo "" >&2
    echo "Failure: the last few lines of the error log ($_TMP/$PatchId.error):" >&2
    tail $_TMP/$PatchId.error >&2
    if [ ! -z "$FileIfInstalled" ] ; then
    	rm -f $FileIfInstalled
    fi
else
    echo "Patch install completed successfully." >&2
    rm -f $_TMP/$PatchId.error $_TMP/$PatchId.output
fi
exit $SSSTAT
