#!/bin/sh
#
# This is a patch after script,  generated by the patchgen script.
# You should not edit this file.
#
_TMP="$TMP"
if [ "x$_TMP" != x ]; then
    # Unscrew NuTcracker screwyness.
    _TMP=`echo "$_TMP" | sed 's!/\([a-zA-Z]\)=/!\1:/!g'`
    if [ ! -d "$_TMP" ]; then
	unset _TMP
    fi
fi
if [ "x$_TMP" = x ]; then
    # This should be a no-op on Unix, but on NT the chances are good that
    # there really will be a $DBDIR/tmp.
    if [ -d tmp ]; then
	_TMP=`pwd`/tmp
    else
	_TMP=/tmp
	if [ ! -d /tmp ]; then
	    mkdir /tmp
	fi
    fi
fi
export _TMP

if [ -f /tmp/TransferEnv ] ; then
    set -a
    . /tmp/TransferEnv
fi

PatchId=SYDM_ESM11_10SYB_GBIN_$1
PATH=${PATH}:/usr/ucb

if [ -d "$ThisDir" ]; then
    cd $ThisDir
fi

sh >$_TMP/${PatchId}.output 2>$_TMP/${PatchId}.error <<\MAIN_EOF
set -xe

# Executing after script:  SybaseSentry/M7SybaseSentryAfter.sh
sh -xe <<\GBIN_EOF

##########################################################################
#
# File    : @(#M) M7SybaseSentryAfter.sh @(#M)
#
# Version : @(#I) /main/2 @(#I)
#
# Created : @(#E) 97/03/14 18:28:39 @(#E)
#
# SCCSID  : @(#) M7SybaseSentryAfter.sh /main/2 97/03/14 18:28:39 @(#)
# 
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# 
# DESCRIPTION
# 
# This is the after script for the SybaseSentry Monitors.
#
# This script is designed for 'wrapping' by the patchgen util, which creates
# the undeclared refs like ThisDir
#
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# 
# CHANGE LOG
# 
# Date       By         Reason
# ------     ----       ----------------------------------------------------
# 01-Aug-95  DJR        Created
# 
##########################################################################

# Print version info

echo "Running M7SybaseSentryAfter.sh version @(#I) /main/2 @(#I)\n"

# Get to installed location

cd $ThisDir/SybaseSentry

#
# If required, Create the default Sentry profile, in the 
# default Sentry profile manager. If it exists, then check
# for updated defaults and drop them first
#

# Grab a few bits
IRO=`wlookup InterRegion`
IROname=`idlcall $IRO _get_name`
IROname=`eval echo $IROname`

# Set out names
DefaultSentryRegionName="Tivoli/Sentry Defaults-$IROname"
DefaultSentryPrfMgrName="Tivoli/Sentry Defaults-$IROname"

DefaultSentryName="TivoliSentryDefaults"
RegionDefaultSentryName="$DefaultSentryName#$IROname"

NoticeGroupName="Sybase Sentry"
RegionNoticeGroupName="$NoticeGroupName#$IROname"

# Check this task needs to be done
if wlookup -r SentryProfile "$RegionDefaultSentryName" >/dev/null 2>&1
then
    # Drop existing Server monitor defaults

    ./M7SybaseServerDefaultsDrop.sh "$RegionDefaultSentryName"

    # Drop existing Database monitor defaults

    ./M7SybaseDatabaseDefaultsDrop.sh "$RegionDefaultSentryName"

else
    echo "$DefaultSentryName does not exist - creating"

    # Check then create policy region

    if wlookup -r PolicyRegion "$DefaultSentryRegionName" > /dev/null 2>&1
    then
        # Already exists so use existing one
        : 
    else 
	echo "Creating Policy Region"
        set -e
        wcrtpr -m SentryProfile -m ProfileManager -m IndicatorCollection \
        "$DefaultSentryRegionName"
        set +e
    fi

    # Check then create profile manager

    if wlookup -r ProfileManager "$DefaultSentryPrfMgrName" > /dev/null 2>&1
    then
        # Already exists so use existing one
        : 
    else 
        echo "Creating default Profile Manager"
        set -e
        wcrtprfmgr "@PolicyRegion:$DefaultSentryRegionName" \
        "$DefaultSentryPrfMgrName"
        set +e
    fi
    
    # Create the default Sentry profile

    echo "Creating $DefaultSentryName"
    DefaultSentry=`wcrtprf "@ProfileManager:$DefaultSentryPrfMgrName" \
    SentryProfile "$DefaultSentryName" | awk '{print $1}'`
    
    # Populate the thing

    echo "Populating"
    wcrtsntcoll "$DefaultSentryRegionName" DefIndCol
    wsetcoll DefIndCol "$RegionDefaultSentryName"
    
fi

# Load SybaseDatabase collection without engine restart option

mcsl -P cat -i M7SybaseDatabase.col

# Load new SybaseDatabase defaults

./M7SybaseDatabaseDefaults.sh "$RegionDefaultSentryName"

# Load SybaseServer collection WITH engine restart option

mcsl -P cat -Ri M7SybaseServer.col

# Load new SybaseServer defaults

./M7SybaseServerDefaults.sh "$RegionDefaultSentryName"

#
# Load Error Category defaults
#

./SetErrorCategory.sh -r

#
# Load Sybase Sentry Notice group with inlined perl script
#

# Check which perl to use

if [ -z "$INTERP" -o "$INTERP" = "w32-ix86" ]
then
        PerlPath="perl";
else
        PerlPath="/etc/Tivoli/bin/perl";
fi

$PerlPath <<EOF

;# Set out some names
;####################

\$WlookupError='Failed Calling wlookup';
\$IdlcallError='Failed Calling idlcall';

;# Check if Sybase Sentry Notice group exists
;#############################################

print "Checking $NoticeGroupName Notice Group\n";

if (\$ENV{'INTERP'} ne 'w32-ix86') {
  open (PIPE,"-|") || exec qwlookup -r TMF_Notice "$RegionNoticeGroupName";
} else {
  open (PIPE,qwlookup -r TMF_Notice "$RegionNoticeGroupName"|) || die \$WlookupError;
}

\$ResponseLine=<PIPE>;
close (PIPE);
if (\$ != 0) { die "Error calling wlookup : \$ResponseLine"; }
    
if (\$ResponseLine =~ /^([0-9]+\.[0-9]+\.[0-9]+)\#.*/) {
    print "$NoticeGroupName Notice Group Already Installed\n";
}
else {

    print "Need To Create Notice Group\n";

    ;# Get notice manager oid
    ;########################
    if (\$ENV{'INTERP'} ne 'w32-ix86') {
        open (PIPE,"-|") || exec "wlookup -r Classes TMF_Notice";
    } else {
        open (PIPE,'wlookup -r Classes TMF_Notice |') || die \$WlookupError;
    }

    \$ResponseLine=<PIPE>;
    close (PIPE);
    if (\$ != 0) { die \$WlookupError; }

    if (\$ResponseLine =~ s/^([0-9]+\.[0-9]+\.[0-9]+)\#.*//) {
        \$NoticeManager = \$1;
    }
    else { die "Cant Find Notice Manager Oid"; }

    ;# Create notice group
    ;#####################

    print "Creating $NoticeGroupName Notice Group\n";

    \$Idl=join(' ','idlcall',
		   \$NoticeManager,
		  qTMF_Notice::NoticeManager::create_notice_group,
                  q\\"$NoticeGroupName\\" 72);

    if (\$ENV{'INTERP'} ne 'w32-ix86') {
        open (PIPE,"-|") || exec \$Idl;
    } else {
        open (PIPE,\$Idl."|") || die \$IdlcallError;
    }
    \$ResponseLine=<PIPE>;
    close (PIPE);
    if (\$ != 0) { die "Idlcall failed with : \$ResponseLine"; }

    if (\$ResponseLine =~ s/^([0-9]+\.[0-9]+\.[0-9]+)\#.*//) {
        \$NoticeGroup = \$1;
    }
    else {
	die "Idlcall failed with : \$ResponseLine";
    }

    ;# Get Bulletin board class oid
    ;##############################

    print "Getting BulletinBoard OID\n";

    if (\$ENV{'INTERP'} ne 'w32-ix86') {
        open (PIPE,"-|") || exec "wlookup -r Classes BulletinBoard";
    } else {
        open (PIPE,'wlookup -r Classes BulletinBoard |') || die \$WlookupError;
    }
    \$ResponseLine=<PIPE>;
    close (PIPE);
    if (\$ != 0) { die \$WlookupError; }

    if (\$ResponseLine =~ s/^([0-9]+\.[0-9]+\.[0-9]+)\#.*//) {
        \$BulletinBoardClass = \$1;
    }
    else {
	die "Cant Find Bulletin Board Class Oid";
    }

    ;# Get Bulletin board instance oid
    ;#################################

    \$Idl=join(' ','idlcall',
		   \$BulletinBoardClass,
                   q lookup_object \\"Notices\\",
                   q'{1 \"TMF_Notices::ViewerAdmin\"}');

    if (\$ENV{'INTERP'} ne 'w32-ix86') {
        open (PIPE,"-|") || exec \$Idl;
    } else {
        open (PIPE,\$Idl."|") || die \$IdlcallError;
    }

    \$ResponseLine=<PIPE>;
    close (PIPE);
    if (\$ != 0) { die \$IdlcallError; }

    if (\$ResponseLine =~ s/^([0-9]+\.[0-9]+\.[0-9]+)\#.*//) {
        \$BulletinBoard = \$1;
    }
    else { die \IdlcallError; }

    ;# Subscribe notice group to bulletin board 
    ;##########################################
    print "Subscribing New Notice Group To Bulletin Board\n";
    \$Idl=join(' ','idlcall',
		   \$BulletinBoard,
		   'subscribe_group',
		   \$NoticeGroup);

    if (\$ENV{'INTERP'} ne 'w32-ix86') {
        open (PIPE,"-|") || exec \$Idl;
    } else {
        open (PIPE,\$Idl."|") || die \$IdlcallError;
    }

    \$ResponseLine=<PIPE>;
    close (PIPE);
    if (\$ != 0) { die \$IdlcallError; }
}
EOF

exit 0

GBIN_EOF

MAIN_EOF

SSSTAT=$?
# any output needs to go to stderr
	 
if [ $SSSTAT -ne 0 ]; then
    echo "" >&2
    echo "Failure: the last few lines of the error log ($_TMP/$PatchId.error):" >&2
    tail $_TMP/$PatchId.error >&2
    if [ ! -z "$FileIfInstalled" ] ; then
    	rm -f $FileIfInstalled
    fi
else
    echo "Patch install completed successfully." >&2
    rm -f $_TMP/$PatchId.error $_TMP/$PatchId.output
fi
exit $SSSTAT
